<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<div :class="['custom-dropdown', { 'open': isOpen }]" @click="toggleDropdown">
		<div class="selected-option">
			<span class="label">Sort by</span> {{ selectedOption.name }}
			<i class="icon-arrow-down"></i>
		</div>
		<ul v-if="isOpen" class="options">
			<li v-for="option in options" :key="option" @click="selectOption(option)" :class="{ 'selected': selectedOption.name === option.name }">{{ option.name }}</li>
		</ul>
	</div>
</template>

<script setup lang="ts">
import { ref } from 'vue';

const { options } = defineProps(['options']);

const isOpen = ref(false);
const selectedOption = ref(options[0]);

const toggleDropdown = () => {
	isOpen.value = !isOpen.value;
};

const selectOption = (option: any) => {
	selectedOption.value = option;
	isOpen.value = false;
	emit('change', selectedOption.value);
};

// expose selected option
defineExpose({ selectedOption });

// emmit event "change" when the selected option changes
const emit = defineEmits(['change']);

</script>